local name, mNameplates = ...

local DEBUG = mNameplates.DEBUG
local Debug = mNameplates.Debug
local expect = Debug.expect

local CI = LibStub("LibConfigUI-1.0"):RegisterConfigScheme(name)

local OptionsWindow
local ConfigTable

function mNameplates:ToggleConfig(ReShow)
	local self = plugin
	
	local Show = false
	
	if OptionsWindow then
		OptionsWindow:Hide()
		if ReShow then Show = true end
	else
		Show = true
	end
	if Show then
		OptionsWindow = CI:RegisterTable(ConfigTable)
		OptionsWindow:Show()
		OptionsWindow:SetCallback("OnClose", function(self, event, ...)
			self:Release()
			OptionsWindow = nil
		end)
	end
end

local ModuleOptions = {}

local TopMenu = {
	widget = "CI-GridSelectGroup",
	type = "group",
	height = 30,	
	layout = "Fill",
	statustable = {},
	groups = {
		{
			name = "General",			
			children = {
				{
					widget = "ScrollFrame", type = "group", layout = "Relative", statustable = {},
					db = function() return mNameplates.db.profile end,
					callback = function() mNameplates:ApplySettings() end,
					children = {						
						{ widget = "CI-InlineGroup", name = "Click Area", type = "group", layout = "Relative", fullwidth = true, template = "Group2",							
							children = {
								{ widget = "CI-Button", name = "Toggle", callback = function() mNameplates:ToggleClickArea() end },
								--{ widget = "CI-Label", name = "The click area is the area that works for selecting the unit with mouse click. Adjust it to the size you want and configure the rest of the mudules after that."},
								{ widget = "CI-NewLine" },
								{ widget = "CI-Slider", name = "Width", key = "Width", min = 0, max = 400, step = 0.1, relwidth = 0.5 },
								{ widget = "CI-Slider", name = "Height", key = "Height", min = 0, max = 200, step = 0.1, relwidth = 0.5 },
							}
						},	
					},
				},
			},
		},
		{
			name = "Modules",
			children = {
				{
					widget = "CI-TreeGroup",
					type = "group",
					layout = "Fill",
					statustable = {},
					groups = ModuleOptions,
				},
			},
		},
	},
}

ConfigTable = {
	type = "group",
	widget = "CI-Frame",
	name = name,
	icon = [[Interface\Icons\INV_Misc_EngGizmos_01]],
	layout = "Fill",
	statustable = {},
	width = 800,
	height = 600,
	children = {
		TopMenu,
	},
}

function mNameplates:AddDisplayModule(name, options)
	if DEBUG then
		expect(name, "typeof", "string")
		expect(options, "typeof", "table")
		expect(ModuleOptions[name], "typeof", "nil")
	end
	ModuleOptions[name] = options
end