local name, mNameplates = ...

local platesToReset = {}
local platesToSetScript = {}
local platesToApply = {}

local stateHeader = CreateFrame("Frame", nil, nil, "SecureHandlerBaseTemplate")
stateHeader:RegisterEvent("PLAYER_REGEN_ENABLED")
stateHeader:SetScript("OnEvent", function(self, event, ...)
	for plate in pairs(platesToReset) do
		mNameplates:ResetLockedAttributes(plate)
	end
	for plate in pairs(platesToSetScript) do		
		mNameplates:SetStateScript(plate)
	end
	for plate in pairs(platesToApply) do
		mNameplates:SetLockedAttributes(plate)
	end	
	wipe(platesToApply)
	wipe(platesToSetScript)
	wipe(platesToReset)
end)

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Combat Wrappers ~~~~~~~~~~
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~

function  mNameplates:CombatWrapperSetStateScript(plate)
	if mNameplates:InCombat() then
		platesToSetScript[plate] = true
	else
		self:SetStateScript(plate)
	end
end

function mNameplates:CombatWrapperApply(plate)
	if mNameplates:InCombat() then
		platesToApply[plate] = true
	else
		self:SetLockedAttributes(plate)
	end
end

function mNameplates:CombatWrapperResetPlate(plate)
	if mNameplates:InCombat() then
		platesToReset[plate] = true
	else
		self:ResetLockedAttributes(plate)
	end
end

function mNameplates:SetStateScript(plate)
	stateHeader:UnwrapScript(plate, "OnShow")
	stateHeader:WrapScript(plate, "OnShow", [[
		self:SetWidth(]]..self.db.profile.Width..[[)
		self:SetHeight(]]..self.db.profile.Height..[[)
	]])
end

function mNameplates:SetLockedAttributes(plate)
	plate:SetWidth(self.db.profile.Width)
	plate:SetHeight(self.db.profile.Height)
end

function mNameplates:ResetLockedAttributes(plate)
	plate:SetWidth(self.BlizzDefaults.Width)
	plate:SetHeight(self.BlizzDefaults.Height)
	stateHeader:UnwrapScript(plate, "OnShow")
end